Index: LMDZ6/trunk/libf/phylmdiso/calltherm.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/calltherm.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/calltherm.F90	(revision 4036)
@@ -405,5 +405,5 @@
             xt_seri(:,:,:) = xt_seri(:,:,:) + d_xt_the(:,:,:)
 #ifdef ISOVERIF
-      write(*,*) 'calltherm 350 tmp: ajout d_xt_the'
+!      write(*,*) 'calltherm 350 tmp: ajout d_xt_the'
       if (iso_HDO.gt.0) then
 !      i=479
Index: LMDZ6/trunk/libf/phylmdiso/isotopes_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/isotopes_mod.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/isotopes_mod.F90	(revision 4036)
@@ -665,7 +665,4 @@
 endif
 
-! fermeture fichier de paramètres
-close(unit=32)
-
 ! nom des isotopes
 
Index: LMDZ6/trunk/libf/phylmdiso/isotopes_routines_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/isotopes_routines_mod.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/isotopes_routines_mod.F90	(revision 4036)
@@ -16063,5 +16063,4 @@
 !      write(*,*) 'xtsnow(4,8,1)=',xtsnow(4,8,1)
 #ifdef ISOVERIF
-      write(*,*) 'phyiso_etat0 15993 tmp: xtsol(iso_eau,1),qsol(1)=',xtsol(iso_eau,1),qsol(1)
       do i=1,klon
          do ixt=1,niso
@@ -16368,5 +16367,5 @@
      &                  *(1-kcin(ixt))/(1.0-kcin(ixt)*h0)
            xt_ancien(ixt,i,k)=q_ancien(i,k)*RMerlivat(ixt) &
-     &                  *(q_ancien(i,k)/q0)**(alpha(ixt)-1.0)
+     &                  *(min(q0,q_ancien(i,k))/q0)**(alpha(ixt)-1.0)
            if (q_ancien(i,k).gt.ridicule) then
            xtl_ancien(ixt,i,k)=ql_ancien(i,k)*alpha(ixt) &
@@ -16468,4 +16467,5 @@
 
 #ifdef ISOVERIF
+      write(*,*) 'phyisoetat0 16468: verif init dure'
       do i=1,klon
          do ixt=1,niso
@@ -16499,6 +16499,21 @@
            if (iso_eau.gt.0) then
              call iso_verif_egalite(xt_ancien(iso_eau,i,k), &
-     &           q_ancien(i,k),'phyiso_etat0_dur 775')        
+     &           q_ancien(i,k),'phyiso_etat0_dur 775a')        
            endif !if (iso_eau.gt.0) then
+           if (iso_HDO.gt.0) then
+             if (q_ancien(i,k).gt.ridicule) then
+              call iso_verif_aberrant_encadre( &
+     &           xt_ancien(iso_hdo,i,k)/q_ancien(i,k), &
+     &          'phyiso_etat0_dur 775b')
+             endif !if (q_ancien(i,k).gt.ridicule) then
+           endif !if (iso_HDO.gt.0) then
+           if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then
+              if (q_ancien(i,k).gt.ridicule) then
+                call iso_verif_O18_aberrant( &
+     &              xt_ancien(iso_hdo,i,k)/q_ancien(i,k), &
+     &              xt_ancien(iso_O18,i,k)/q_ancien(i,k), &
+     &              'phyiso_etat0_dur 775c')
+              endif ! if (q_ancien(i,k).gt.ridicule) then
+           endif ! if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then 
          enddo !do k=1,klev
          do nsrf=1,nbsrf
Index: LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90	(revision 4036)
@@ -2435,5 +2435,5 @@
 #endif
 #ifdef ISOVERIF
-        write(*,*) 'pbl_surface_mod 1060: sortie surf_landice'
+        !write(*,*) 'pbl_surface_mod 1060: sortie surf_landice'
         do j=1,knon
           if (iso_eau.gt.0) then     
@@ -2530,5 +2530,5 @@
 #endif
 #ifdef ISOVERIF
-        write(*,*) 'pbl_surface_mod 1077: sortie surf_seaice'
+        !write(*,*) 'pbl_surface_mod 1077: sortie surf_seaice'
         do j=1,knon
           if (iso_eau.gt.0) then     
@@ -3275,5 +3275,5 @@
 #ifdef ISO
 #ifdef ISOVERIF
-       write(*,*) 'pbl_surface 2858'
+       !write(*,*) 'pbl_surface 2858'
        DO i = 1, klon
         do ixt=1,niso
Index: LMDZ6/trunk/libf/phylmdiso/phyetat0.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4036)
@@ -507,5 +507,5 @@
          enddo
       endif
-            write(*,*) 'phyetat0 1102'
+      write(*,*) 'phyetat0 1102'
 #endif
 #endif
Index: LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90	(revision 4036)
@@ -2614,7 +2614,7 @@
         ENDIF !IF (iso_HTO.gt.0) then
 
-    write(*,*) 'phys_output_write_mod 2531'
+    !write(*,*) 'phys_output_write_mod 2531'
     enddo !do ixt=1,ntraciso    
-    write(*,*) 'phys_output_write_mod 1777'    
+    !write(*,*) 'phys_output_write_mod 1777'    
 #endif
 
Index: LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4036)
@@ -2354,5 +2354,5 @@
 #ifdef ISO
 #ifdef ISOVERIF
-    write(*,*) 'physiq 1847: qx(1,1,:)=',qx(1,1,:)
+!    write(*,*) 'physiq 1847: qx(1,1,:)=',qx(1,1,:)
     write(*,*) 'physiq 1846b: ok_isotopes,ntraciso,niso=',ok_isotopes,ntraciso,niso
 #endif
@@ -2467,5 +2467,5 @@
     ! Diagnostiquer la tendance dynamique
 #ifdef ISOVERIF
-      write(*,*) 'physiq tmp 2010: ancien_ok=',ancien_ok       
+      !write(*,*) 'physiq tmp 2010: ancien_ok=',ancien_ok       
       if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then  
         do i=1,klon 
@@ -4393,5 +4393,5 @@
 #endif         
 #ifdef ISOVERIF
-      write(*,*) 'physiq 3691b: avant call ajsec'
+      write(*,*) 'physiq 3691c: avant call ajsec'
       if (iso_eau.gt.0) then
       call iso_verif_egalite_vect2D( &
Index: LMDZ6/trunk/libf/phylmdiso/wake.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/wake.F90	(revision 4035)
+++ LMDZ6/trunk/libf/phylmdiso/wake.F90	(revision 4036)
@@ -355,7 +355,7 @@
 
   ! print*, 'wake initialisations'
-#ifdef ISOVERIF
-        write(*,*) 'wake 358: entree'
-#endif
+!#ifdef ISOVERIF
+!        write(*,*) 'wake 358: entree'
+!#endif
 
   ! Essais d'initialisation avec sigmaw = 0.02 et hw = 10.
@@ -497,7 +497,4 @@
   ! ------------------------------------------------------------------------
 
-#ifdef ISOVERIF
-        write(*,*) 'wake 500: debut inits'
-#endif
 !jyg<
 !!  DO k = 1, klev
@@ -549,7 +546,4 @@
 #endif
 
-#ifdef ISOVERIF
-        write(*,*) 'wake 552: milieu inits'
-#endif
       IF (iflag_wk_act == 0) THEN
         act(:) = 0.