Index: LMDZ6/trunk/libf/dynphy_lonlat/calfis.F
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/calfis.F	(revision 4034)
+++ LMDZ6/trunk/libf/dynphy_lonlat/calfis.F	(revision 4046)
@@ -29,5 +29,5 @@
 c    Auteur :  P. Le Van, F. Hourdin 
 c   .........
-      USE infotrac, ONLY: nqtot, niadv, tname
+      USE infotrac, ONLY: nqtot, niadv, tracers
       USE control_mod, ONLY: planet_type, nsplit_phys
 #ifdef CPP_PHYS
@@ -481,5 +481,5 @@
          lafin_split=lafin.and.isplit==nsplit_phys
 
-        CALL call_physiq(ngridmx,llm,nqtot,tname,
+        CALL call_physiq(ngridmx,llm,nqtot,tracers(:)%name,
      &                   debut_split,lafin_split,
      &                   jD_cur,jH_cur_split,zdt_split,
@@ -522,5 +522,5 @@
 !     .             llm,            !! nlayer
 !     .             nqtot,          !! nq
-!     .             tname,          !! tracer names from dynamical core (given in infotrac)
+!     .             tracers(:)%name,!! tracer names from dynamical core (given in infotrac)
 !     .             debut_split,    !! firstcall 
 !     .             lafin_split,    !! lastcall
Index: LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F	(revision 4034)
+++ LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F	(revision 4046)
@@ -45,5 +45,5 @@
       USE Times
 #endif
-      USE infotrac, ONLY: nqtot, niadv, tname
+      USE infotrac, ONLY: nqtot, niadv, tracers
       USE control_mod, ONLY: planet_type, nsplit_phys
 #ifdef CPP_PHYS
@@ -731,5 +731,5 @@
          lafin_split=lafin.and.isplit==nsplit_phys
 
-        CALL call_physiq(klon,llm,nqtot,tname,
+        CALL call_physiq(klon,llm,nqtot,tracers(:)%name,
      &                   debut_split,lafin_split,
      &                   jD_cur,jH_cur_split,zdt_split,
Index: LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 4034)
+++ LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 4046)
@@ -39,4 +39,5 @@
   USE comvert_mod, ONLY: ap, bp, preff, pressure_exner
   USE temps_mod, ONLY: annee_ref, day_ref, itau_dyn, itau_phy, start_time
+  USE strings_mod, ONLY: strLower
   
   IMPLICIT NONE
@@ -74,5 +75,5 @@
   USE exner_hyb_m,    ONLY: exner_hyb
   USE exner_milieu_m, ONLY: exner_milieu
-  USE infotrac,       ONLY: nqtot, tname
+  USE infotrac,       ONLY: nqtot, tracers
   USE filtreg_mod
   IMPLICIT NONE
@@ -84,5 +85,5 @@
 ! Local variables:
   CHARACTER(LEN=256) :: modname, fmt
-  INTEGER            :: i, j, l, ji, itau, iday
+  INTEGER            :: i, j, l, ji, itau, iday, iq
   REAL               :: xpn, xps, time, phystep
   REAL, DIMENSION(iip1,jjp1)       :: psol
@@ -145,5 +146,5 @@
 ! Look for ozone tracer:
 #ifndef INCA
-  DO i=1,nqtot; IF(ANY(["O3","o3"]==tname(i))) EXIT; END DO
+  DO iq=1,nqtot; IF(strLower(tracers(iq)%name)=="o3") EXIT; END DO
   IF(i/=nqtot+1) THEN
     CALL regr_lat_time_coefoz
Index: LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4034)
+++ LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4046)
@@ -16,5 +16,5 @@
   USE mod_phys_lmdz_para, ONLY: klon_omp ! number of columns (on local omp grid)
   USE vertical_layers_mod, ONLY : init_vertical_layers
-  USE infotrac, ONLY: nqtot,nqo,nbtr,nqCO2,tname,ttext,type_trac,&
+  USE infotrac, ONLY: nqtot,nqo,nbtr,nqCO2,tracers,type_trac,&
                       niadv,conv_flg,pbl_flg,solsym,&
                       nqfils,nqdesc,nqdesc_tot,iqfils,iqpere,&
@@ -146,5 +146,5 @@
 
   ! Initialize tracer names, numbers, etc. for physics
-  CALL init_infotrac_phy(nqtot,nqo,nbtr,nqtottr,nqCO2,tname,ttext,type_trac,&
+  CALL init_infotrac_phy(nqtot,nqo,nbtr,nqtottr,nqCO2,tracers,type_trac,&
                          niadv,conv_flg,pbl_flg,solsym,&
                          nqfils,nqdesc,nqdesc_tot,iqfils,iqpere,&
@@ -203,9 +203,9 @@
           rlonudyn,rlatudyn,rlonvdyn,rlatvdyn)
 #endif
-    IF (type_trac == 'repr') THEN
-#ifdef REPROBUS
-       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
-#endif
-    END IF
+  END IF
+  IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+     CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+#endif
   END IF
 