Index: /BOL/script_install/check_version.sh
===================================================================
--- /BOL/script_install/check_version.sh	(revision 4100)
+++ /BOL/script_install/check_version.sh	(revision 4101)
@@ -407,4 +407,4 @@
 
 if [ $mail_address != "" ] ; then
-   ssh lmdz@django "mail -s 'Nouvelle version (recheck.sh)' $mail_address < "$local_d"/tmp.message"
-fi
+   ssh lmdz@django "mail -s 'Nouvelle version pour install.sh' $mail_address < "$local_d"/tmp.message"
+fi
Index: /BOL/script_install/creation_modipsl.sh
===================================================================
--- /BOL/script_install/creation_modipsl.sh	(revision 4100)
+++ /BOL/script_install/creation_modipsl.sh	(revision 4101)
@@ -9,5 +9,5 @@
 branche=IPSLCM6.0.15
 branche=trunk
-rev="-r r3258"
+rev="-r 4084"
 rev=""
 latest=""
@@ -21,4 +21,5 @@
 fi
 
+check=0
 check=1 # On verifie un certain nombre de choses.
 force=0
@@ -65,5 +66,5 @@
    branchepath=branches/$branche
 fi
-svnmodel=http://svn.lmd.jussieu.fr/LMDZ/$LMDZv/$branchepath
+svnmodel=https://svn.lmd.jussieu.fr/LMDZ/$LMDZv/$branchepath
 
 
@@ -78,5 +79,5 @@
 if [  "$datesvn" = "" ] ; then
 #    DATESVN vide
-    datesvn=`svn info http://svn.lmd.jussieu.fr/LMDZ/$LMDZv/$branchepath $rev | grep 'Date de la dern' | awk ' { print $6 } '  | sed -e 's/-//g'`
+    datesvn=`svn info https://svn.lmd.jussieu.fr/LMDZ/$LMDZv/$branchepath $rev | grep 'Date de la dern' | awk ' { print $6 } '  | sed -e 's/-//g'`
 fi
 echo datesvn $datesvn
@@ -158,51 +159,13 @@
 
 
-## Modif Ehouarn: on garde les sources d'IOIPSL de $modipsltar 
-#mkdir -p IOIPSL
-#cd IOIPSL
-#\rm -r src
-# cp -r /u/lmdz/WWW/Distrib/IOIPSL/src_fairhead_v3c src
-# A partir du  13/10/2008
-#cp -r /u/lmdz/WWW/Distrib/IOIPSL/src_20081014 src
-#cd ../../..
-
 cd ../..
 echo $version
 tar cvf modipsl.$version.tar modipsl
 
-
 gzip modipsl.$version.tar
 mv modipsl.$version.tar.gz ~/WWW/Distrib
 
-# 2022/02/17 on ne fait plus qu'une seule archive a partir de la version ORCHIDEE/CMIP6
-## en attendant la bascule sur orchide CMIP, on fait un modipsl.tar avec la nouvelle version d'orchidee
-##modipsltar=modipsl_orc_cmip6.$vorig.tar
-##tmpdir=$local/tmpmodipslcmip6$$
-##mkdir -p $tmpdir
-##cd $tmpdir
-##if [ -f /u/lmdz/WWW/Distrib/$modipsltar.gz ] ; then
-##   cp /u/lmdz/WWW/Distrib/$modipsltar.gz .
-##else
-##   wget http://www.lmd.jussieu.fr/~lmdz/Distrib/$modipsltar.gz
-##fi
-##tar xvf $modipsltar.gz
-##cd modipsl/modeles
-##
-##echo Second svn checkout $rev $svnmodel $LMDZ
-###ssh butler ' ( cd '`pwd`' ; svn checkout '$rev' '$svnmodel' '$LMDZ' ) '
-##svn checkout $rev $svnmodel $LMDZ
-##cd ../..
-##echo $version
-##tar cvf modipsl_orc_cmip6.$version.tar modipsl
-##
-##
-##gzip modipsl_orc_cmip6.$version.tar
-##mv modipsl_orc_cmip6.$version.tar.gz ~/WWW/Distrib
-
-#######
-
 cd  ~/WWW/Distrib
 ln -sf modipsl.$version.tar.gz modipsl.$branche.tar.gz
-##ln -sf modipsl_orc_cmip6.$version.tar.gz modipsl_orc_cmip6.$branche.tar.gz
 cd ~/WWW/pub/src
 
@@ -210,48 +173,16 @@
 ln -sf ../../Distrib/modipsl.$version.tar.gz .
 ln -sf modipsl.$version.tar.gz modipsl.$branche.tar.gz
-##ln -sf ../../Distrib/modipsl_orc_cmip6.$version.tar.gz .
-##ln -sf modipsl_orc_cmip6.$version.tar.gz modipsl_orc_cmip6.$branche.tar.gz
 cd  ~/WWW/Distrib
 
 
+####################################################################
+# La partie ci-dessous concerne le check des versions.
+# On devrait sans doute appeler rechech.sh
+####################################################################
+
 if [ $check = 1 ] ; then
-./check_version.sh $version >| WORK/check.out.$version 2>&1
-#./check_version_old.sh $version >| WORK/check.out 2>&1
-tmpcheck=`tail -1 WORK/check.out.$version`
-echo "$tmpcheck" >> Correspondance
-echo "$tmpcheck" >> LISMOI.$branche
-
-\cp -f LISMOI.trunk ../pub/src/Readme
-
-
-# mail -r lmdz-owner -s "Nouvelle version pour install.sh" poihl@lmd.jussieu.fr <<eod
-ssh lmdz@django "mail -s 'Nouvelle version pour install.sh' lmdz-commit@listes.lmd.ipsl.fr <<eod
-
-disponible sur
-https://www.lmd.jussieu.fr/~lmdz/Distrib/modipsl.$version.tar.gz
-
-      Test local LMD network, gfortran, 48x36x19
-      ==========================================
-
-install version         SVN     Bench   Conv.   1+1=2   Init
-                                run     Nnum.      &
-                                        /prev.  mpiXomp
-
-$tmpcheck
-
-
-                                        ||
-                                        \/
-
-S/s/-: 3D standard physics  Converging/runing/not runing
-N/n/-: -  new        -                  -
-D/d/-: new with debug                   -
-U/u/-: unicolonne                       -
-I/i/x/-: isotope            Converging/runing/run failed /compiled failed
-noc: runs but no convergence
-OK <=> SNDUI
-
-eod
-"
-
+   ./check_version.sh $version >| WORK/check.out.$version 2>&1
+   cat tmp.resu >> Correspondance
+   cat tmp.resu >> LISMOI.$branche
+   \cp -f LISMOI.trunk ../pub/src/Readme
 fi